'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _ufunc = require('ufunc');

var _ufunc2 = _interopRequireDefault(_ufunc);

var _posOffset = require('./posOffset');

var _posOffset2 = _interopRequireDefault(_posOffset);

var _ramda = require('ramda');

var _ramda2 = _interopRequireDefault(_ramda);

var _reactUikitBase = require('react-uikit-base');

var _reactUikitBase2 = _interopRequireDefault(_reactUikitBase);

var _reactUikitTrigger = require('../../react-uikit-trigger');

var _reactUikitTrigger2 = _interopRequireDefault(_reactUikitTrigger);

var _dropbody = require('./dropbody');

var _dropbody2 = _interopRequireDefault(_dropbody);

var _reactUikitButton = require('react-uikit-button');

var _reactUikitButton2 = _interopRequireDefault(_reactUikitButton);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Dropdown = function (_React$Component) {
  _inherits(Dropdown, _React$Component);

  function Dropdown() {
    _classCallCheck(this, Dropdown);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(Dropdown).apply(this, arguments));
  }

  _createClass(Dropdown, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      if (!this.props.hover) {
        window.addEventListener('click', function (e) {
          return _this2.handleClickListener(e);
        }, false);
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      var _this3 = this;

      if (!this.props.hover) {
        window.removeEventListener('click', function (e) {
          return _this3.handleClickListener(e);
        }, false);
      }
    }
  }, {
    key: 'animate',
    value: function animate(state, trigger) {
      return function (element) {
        var animateIn = function animateIn() {
          trigger.animate.in(element, state);
        };

        var animateOut = function animateOut() {
          trigger.animate.out(element, state);
        };

        _ufunc2.default.either(animateIn, animateOut)(state);
      };
    }
  }, {
    key: 'getDropbody',
    value: function getDropbody(dataId) {
      return this.getElement('dropbody-' + dataId);
    }
  }, {
    key: 'getElement',
    value: function getElement(dataId) {
      return _reactUikitBase2.default.helpers.getElement(dataId);
    }
  }, {
    key: 'listener',
    value: function listener(target, dataId) {
      var parent = target.parentNode;
      var kitid = 'dropTrigger-' + dataId;
      var targetId = target.getAttribute('data-kitid');
      var parentId = parent.getAttribute('data-kitid');
      var dropbody = this.getDropbody(dataId);

      return function (callback) {
        callback(targetId, parentId, kitid, dropbody);
      };
    }
  }, {
    key: 'handleClickListener',
    value: function handleClickListener(e) {
      var _this4 = this;

      var target = e.target;

      var callback = function callback(targetId, parentId, kitid, dropbody) {
        if (targetId !== kitid && parentId !== kitid) {

          if (_this4.props.opened) {
            _this4.animate(false, _this4.props.trigger)(dropbody);
          }
        }
      };

      this.listener(target, this.props.kitid)(callback);
    }
  }, {
    key: 'handleTriggerHover',
    value: function handleTriggerHover(e) {
      var _this5 = this;

      var target = e.target;

      if (this.props.hover) {
        var callback = function callback(targetId, parentId, kitid, dropbody) {
          dropbody.style.display = 'block';
          dropbody.style.visibility = 'hidden';

          _this5.animate(!_this5.props.opened, _this5.props.trigger)(dropbody);
        };

        this.listener(target, this.props.kitid)(callback);
      }
    }
  }, {
    key: 'handleTriggerClick',
    value: function handleTriggerClick(e) {
      var _this6 = this;

      e.preventDefault();
      var props = this.props;
      var dropbody = this.getDropbody(props.kitid);
      var trigger = e.currentTarget;

      var toHidden = function toHidden(element) {
        element.style.display = 'block';
        element.style.visibility = 'hidden';

        return element;
      };

      var justify = function justify(element) {
        if (props.justify) {
          var _justify = _this6.getElement(props.justify);
          element.style.width = _posOffset2.default.dim(_justify).width + 'px';
        }

        return element;
      };

      var getPosition = function getPosition(element) {
        var elementOffset = _posOffset2.default.offset({
          target: trigger,
          element: element,
          flip: !props.noflip,
          boundary: props.boundary
        })(props.pos);

        element.style.top = elementOffset.top + 'px';

        if (props.type === 'button-group') {
          var buttonGroup = document.querySelector('.uk-button-group');
          var paddingLeft = window.getComputedStyle(buttonGroup, null).getPropertyValue('padding-left');

          element.style.left = paddingLeft;
        } else {
          element.style.left = elementOffset.left + 'px';
        }

        return element;
      };

      _ramda2.default.pipe(toHidden, justify, getPosition, this.animate(!this.props.opened, props.trigger))(dropbody);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this7 = this;

      var props = this.props;
      var kitid = _ufunc2.default.either(props.kitid, props.kitid)(props.kitid);

      // CSS classes
      var type = {
        button: 'uk-button-dropdown',
        'button-group': 'uk-button-group',
        dropdown: null,
        navbar: 'uk-parent'
      };

      var cssClassNames = _reactUikitBase2.default.helpers.cleanClasses([type[props.type] || type['dropdown'], props.classes, props.className]);

      var cssDropClassNames = _reactUikitBase2.default.helpers.cleanClasses([!props.blank ? 'uk-dropdown' : 'uk-dropdown-blank', props.grid ? 'uk-dropdown-width-' + props.grid : null, props.scrollable ? 'uk-dropdown-scrollable' : null, props.small ? 'uk-dropdown-small' : null, props.type === 'navbar' ? 'uk-dropdown-navbar' : null]);

      // Elements
      var cleanProps = _reactUikitBase2.default.helpers.cleanProps(['type'])(props);
      var cleanTriggerProps = _ufunc2.default.either(_reactUikitBase2.default.helpers.cleanProps(props.trigger, ['body', 'icon']), props.trigger)(props.type === 'button-group');

      var attr = _extends({
        'aria-haspopup': 'true',
        'aria-expanded': this.props.opened ? 'true' : 'false',
        'data-kitid': 'dropContainer-' + kitid,
        className: cssClassNames,
        kitid: props.kitid
      }, _reactUikitBase2.default.events(props));

      var dropbodyProps = Object.assign(_extends({
        style: props.justify ? { width: _posOffset2.default.dim(this) } : null,
        'data-kitid': 'dropbody-' + kitid
      }, _reactUikitBase2.default.events(props), {
        className: cssDropClassNames
      }), props.dropbody ? props.dropbody : {});

      var grid = _react2.default.createElement(
        'div',
        { className: 'uk-grid uk-dropdown-grid' },
        props.children
      );

      var dropbody = _react2.default.createElement(
        _dropbody2.default,
        dropbodyProps,
        _ufunc2.default.either(function () {
          return grid;
        }, function () {
          return props.children;
        })(props.grid)
      );

      var trigger = function trigger(mode) {
        return _react2.default.createElement(_reactUikitTrigger2.default, _extends({}, cleanTriggerProps, {
          icon: props.icon || 'caret-down',
          kitid: 'dropTrigger-' + kitid,
          onClick: function onClick(e) {
            return _this7.handleTriggerClick(e);
          },
          onMouseEnter: function onMouseEnter(e) {
            return _this7.handleTriggerHover(e);
          },
          onMouseLeave: function onMouseLeave(e) {
            return _this7.handleTriggerHover(e);
          }
        }));
      };

      var component = {
        dropdown: _react2.default.createElement(
          'div',
          _extends({}, cleanProps, attr),
          trigger(),
          dropbody
        ),

        'button-group': _react2.default.createElement(
          'div',
          _extends({}, cleanProps, attr),
          _react2.default.createElement(
            _reactUikitButton2.default,
            props.standard,
            props.children
          ),
          _react2.default.createElement(
            'div',
            null,
            trigger('link'),
            dropbody
          )
        ),

        navbar: _react2.default.createElement(
          'li',
          _extends({}, cleanProps, attr),
          _react2.default.createElement(
            _reactUikitButton2.default,
            null,
            props.children
          ),
          _react2.default.createElement(
            'div',
            null,
            trigger('link'),
            dropbody
          )
        )
      };

      // Return Component
      return component[props.type] || component['dropdown'];
    }
  }]);

  return Dropdown;
}(_react2.default.Component);

Dropdown.propTypes = {
  blank: _react2.default.PropTypes.bool,
  boundary: _react2.default.PropTypes.string,
  dropbody: _react2.default.PropTypes.object,
  children: _react2.default.PropTypes.any,
  className: _react2.default.PropTypes.string,
  classes: _react2.default.PropTypes.array,
  grid: _react2.default.PropTypes.string,
  hover: _react2.default.PropTypes.bool,
  items: _react2.default.PropTypes.array,
  justify: _react2.default.PropTypes.string,
  kitid: _react2.default.PropTypes.string,
  navbar: _react2.default.PropTypes.bool,
  noflip: _react2.default.PropTypes.bool,
  opened: _react2.default.PropTypes.bool,
  parent: _react2.default.PropTypes.bool,
  pos: _react2.default.PropTypes.string,
  scrollable: _react2.default.PropTypes.bool,
  small: _react2.default.PropTypes.bool,
  standard: _react2.default.PropTypes.object,
  trigger: _react2.default.PropTypes.object,
  type: _react2.default.PropTypes.oneOf(['button', 'button-group', 'dropdown', 'grid', 'navbar'])
};

exports.default = _reactUikitBase2.default.base(Dropdown);